<?php
/* =====================================================================
 * Dieses Skript ist Teil von "Wetter-Analyse in Dekaden (WADE)"
 * Von "Trixi aus Witten/NRW" - http://taw-wade.kilu.de/
 *                 Version 15.07.01 - Build 24.07.2015
 * Lizenziert unter "Namensnennung-Weitergabe unter gleichen Bedingungen
 * 3.0 Deutschland (CC BY-SA 3.0)"
 *                 ==> http://creativecommons.org/licenses/by-sa/3.0/de/
 *
 * Diese Software ist FREIE SOFTWARE und wird mit der Hoffnung, daß sie
 * nützlich sein könnte, zur Verfügung gestellt, jedoch OHNE JEDE
 * GEWÄHRLEISTUNG. Auch nicht für eine ALLGEMEINE GEBRAUCHSTAUGLICHKEIT
 * oder Stabilität für die NUTZUNG ZU EINEM BESTIMMTEN ZWECK. Die freie
 * Software, von der hier die Rede sein soll, ist kein "Freibier",
 * sondern sie gibt dir die Freiheiten
 *
 *   o  die Software für einen beliebigen Zweck auszuführen
 *   o  die Funktionsweise der Software zu studieren und sie an deine
 *      eigenen Bedürfnisse anzupassen
 *   o  Kopien der Software weiterzugeben
 *   o  sowie die Software zu verbessern und diese Verbesserungen zu
 *      veröffentlichen.
*/
// @module strasse "\t\tErmittelt eine Liste der Dauer von Tagen an denen\n\t\t\tdie Bedingung zutrifft\n"
$DA->KonsolenAusgabe('Beginne mit der Ausführung von '.basename(__FILE__),1);
	if ( !is_dir($einstellungen['zwischenspeicher']['speicher_pfad']) )
	$DA->KonsolenAusgabe('Das Verzeichnis für den Zwischenspeicher existiert nicht',-1);
	if ( strlen($DA->cli_parameter['station']) < 4 )
	$DA->KonsolenAusgabe('Es wurde keine Station mit "--station=[name]" angegeben',-1);
	if ( !isset($einstellungen['daten'][$DA->cli_parameter['station']]) )
	$DA->KonsolenAusgabe('Diese Station befindet sich nicht in der Konfiguration',-1);
	if ( $DA->cli_parameter['vergleich'] === '' )
	$DA->KonsolenAusgabe('Es wurde kein Vergleichszeitraum mit "--vergleich=[jahre]" angegeben',-1);
	if ( $DA->cli_parameter['bedingung'] === '' )
	$DA->KonsolenAusgabe('Es wurde keine Bedingung mit --bedingung angegeben',-1);

preg_match('/^([a-z_]+)\s+([<>=]{1,2})\s+([0-9\-\.]+)$/uiD',$DA->cli_parameter['bedingung'],$bedingungen);
	if ( !is_array($bedingungen) || sizeof($bedingungen) !== 4 )
	$DA->KonsolenAusgabe('Es wurde keine gültige Bedingung angegeben',-1);
	if ( !in_array($bedingungen[1],$DA->datenreihen,true) )
	$DA->KonsolenAusgabe('Die gewählte Datenreihe in der Bedingung existiert nicht',-1);

    function WADE_Strasse_Bauen($weiterbauen,$wert,&$datum,&$ergebnis){
    global $einstellungen;
    static $strasse = array('steine'=>array(),'werte'=>array(),'durchschnitt'=>0,'fehlzaehler'=>0,'loecher'=>array('details'=>array(),'anzahl'=>0));
		if ( $weiterbauen ){
		$strasse['steine'][] = $datum;
		$strasse['werte'][$datum] = $wert;
		}
		else{
			if ( sizeof($strasse['steine']) === 0 )
			return true;
		$strasse['fehlzaehler']++;
		$strasse['loecher']['details'][$datum] = $wert;
			if ( sizeof($strasse['steine']) >= $einstellungen['strasse']['mindest_steine'] ){
			$start = min($strasse['steine']);
			$schluessel = sprintf('%04d,%d',sizeof($strasse['steine']),$start);
				if ( $strasse['loecher']['anzahl'] > 0 )
				$alle_werte = array_merge($strasse['werte'],$strasse['loecher']['details']);
				else
				$alle_werte = $strasse['werte'];
			$ergebnis[$schluessel] = array('start'=>$start,'ende'=>max($strasse['steine']),'werte'=>$strasse['werte'],'durchschnitt'=>(array_sum($alle_werte)/sizeof($alle_werte)),'loecher'=>$strasse['loecher']);
			}
			if ( $strasse['fehlzaehler'] > $einstellungen['strasse']['erlaubte_loecher'] ){
			$strasse = array('steine'=>array(),'werte'=>array(),'durchschnitt'=>0,'fehlzaehler'=>0,'loecher'=>array('details'=>array(),'anzahl'=>0));
			}
		}
    }

    function WADE_Strasse_Falsche_Loecher_Entfernen(&$ergebnis){
		foreach ( $ergebnis as $schluessel=>$werte ){
			foreach ( $werte['loecher']['details'] as $datum=>$wert ){
				if ( (int)$datum > (int)$werte['ende'] )
				unset($ergebnis[$schluessel]['loecher']['details'][$datum]);
			}
		$ergebnis[$schluessel]['loecher']['anzahl'] = sizeof($ergebnis[$schluessel]['loecher']['details']);
		}
    }

$DA->KonsolenAusgabe('Suche nach kleinen und grossen Strassen mit der Bedingung',2);
$datensatz = $DA->HoleRoheDatenDerJahre($DA->cli_parameter['station'],$DA->cli_parameter['vergleich']);
$dekaden_auswahl = $DA->ErmittleDekadenAuswahl('strasse');
$strasse = array('steine'=>array(),'loecher'=>0);
$ergebnis = array();

	foreach ( $datensatz as $daten ){
	$datum = sprintf('%04d%02d%02d',$daten['jahr'],$daten['monat'],$daten['tag']);
	$DA->UngueltigeDatensaetzeEntfernen($daten,$datum);
	$dekade = $DA->ErmittleDekade($daten['tag']);
	$schluessel = $daten['monat'].'/'.$dekade;
		if ( in_array($schluessel,$dekaden_auswahl) ){
			switch ( $bedingungen[2] ){
			case '<':
				if ( $daten[$bedingungen[1]] < doubleval($bedingungen[3]) )
				WADE_Strasse_Bauen(true,$daten[$bedingungen[1]],$datum,$ergebnis);
				else
				WADE_Strasse_Bauen(false,$daten[$bedingungen[1]],$datum,$ergebnis);
			break;
			case '<=':
				if ( $daten[$bedingungen[1]] <= doubleval($bedingungen[3]) )
				WADE_Strasse_Bauen(true,$daten[$bedingungen[1]],$datum,$ergebnis);
				else
				WADE_Strasse_Bauen(false,$daten[$bedingungen[1]],$datum,$ergebnis);
			break;
			case '>=':
				if ( $daten[$bedingungen[1]] >= doubleval($bedingungen[3]) )
				WADE_Strasse_Bauen(true,$daten[$bedingungen[1]],$datum,$ergebnis);
				else
				WADE_Strasse_Bauen(false,$daten[$bedingungen[1]],$datum,$ergebnis);
			break;
			case '>':
				if ( $daten[$bedingungen[1]] > doubleval($bedingungen[3]) )
				WADE_Strasse_Bauen(true,$daten[$bedingungen[1]],$datum,$ergebnis);
				else
				WADE_Strasse_Bauen(false,$daten[$bedingungen[1]],$datum,$ergebnis);
			break;
			case '=':
				if ( $daten[$bedingungen[1]] == doubleval($bedingungen[3]) )
				WADE_Strasse_Bauen(true,$daten[$bedingungen[1]],$datum,$ergebnis);
				else
				WADE_Strasse_Bauen(false,$daten[$bedingungen[1]],$datum,$ergebnis);
			break;
			}
		}
	}

$DA->KonsolenAusgabe('Entferne üngültige Löcher aus den Ergebnissen',2);
WADE_Strasse_Falsche_Loecher_Entfernen($ergebnis);

// NOTE: Hmm, das sollte so klappen. Immer die längsten Strassen zuerst,
//       dann gegebenenfalls die mehrfachen filtern und bei Bedarf wieder umsortieren.
krsort($ergebnis);

/*	if ( $einstellungen['strasse']['ergebnis_sortieren'] === 'aufsteigend' )
	ksort($ergebnis);
	elseif ( $einstellungen['strasse']['ergebnis_sortieren'] === 'absteigend' )
	krsort($ergebnis);*/

	if ( $einstellungen['strasse']['mehrfaches_anfangsdatum_filtern'] ){
	// absteigend  = Die längste Strasse mit gleichem Anfangsdatum bleibt erhalten.
	// aufsteigend = Ohne krsort() würde die kürzeste erhalten bleiben. Nicht die "längste kurze".
	$anfangsdatum = array();
	$DA->KonsolenAusgabe('Filtere mehrfache Einträge mit demselben Anfangsdatum heraus',2);
		foreach ( $ergebnis as $schluessel=>$wert ){
			if ( in_array($wert['start'],$anfangsdatum,true) ){
			$DA->KonsolenAusgabe('Entferne mehrfaches Startdatum "'.$wert['start'].'" ('.$wert['loecher']['anzahl'].' Löcher)',2);
			unset($ergebnis[$schluessel]);
			}
			else
			$anfangsdatum[] = $wert['start'];
		}
	}

	if ( $einstellungen['strasse']['ergebnis_sortieren'] === 'aufsteigend' )
	ksort($ergebnis);

$DA->KonsolenAusgabe('Datenbearbeitung beendet',1);
$DA->KonsolenAusgabe('Erstellen des Reports vom Typ '.$DA->cli_parameter['typ'],1);
define('LF',"\r\n"); // \r\n für bessere Lesbarkeit unter Windows beim Standardeditor
$report = '';

	switch ( $DA->cli_parameter['typ'] ){
	case 'text':
	$report .= str_repeat('=',72).LF;
	$report .= 'GEFUNDENE STRASSEN IM ZEITRAUM '.$DA->cli_parameter['vergleich'].LF;
	$report .= 'Erstellt am '.strftime(WADE_FDATE,time()).LF;
	$report .= 'Name der Station: '.$einstellungen['daten'][$DA->cli_parameter['station']]['name'].
		' ('.$einstellungen['daten'][$DA->cli_parameter['station']]['code'].')'.LF;
	$report .= 'Daten-Quelle: '.$einstellungen['daten'][$DA->cli_parameter['station']]['quelle'].LF;
	$report .= 'Bedingung: '.$DA->cli_parameter['bedingung'].LF;
	$report .= 'Erlaubte Löcher: '.$einstellungen['strasse']['erlaubte_loecher'].LF.LF;
		if ( !empty($einstellungen['strasse']['kommentar']) )
		$report .= $einstellungen['strasse']['kommentar'].LF.LF;
	$a = 1;
		foreach ( $ergebnis as $schluessel=>$wert ){
			if ( $a > (int)$einstellungen['strasse']['ergebnis_anzahl'] )
			break;
		$schluessel = explode(',',$schluessel);
		$report .= chr(9).str_pad($a,strlen((int)$einstellungen['strasse']['ergebnis_anzahl']),' ',STR_PAD_LEFT).'.'.chr(9);
			if ( $einstellungen['strasse']['durchschnitt_anzeigen'] )
			$durchschnitt = ' (∅ '.$DA->HuebscheZahlen($wert['durchschnitt'],1,false).')';
			else
			$durchschnitt = '';
			if ( $wert['loecher']['anzahl'] === 0 )
			$report .= 'Durchgängig '.intval($schluessel[0]).' Tage lang'.$durchschnitt.LF;
			else{
				if ( $wert['loecher']['anzahl'] > 1 )
				$report .= intval($schluessel[0]+$wert['loecher']['anzahl']).' Tage lang mit '.$wert['loecher']['anzahl'].' Unterbrechungen'.$durchschnitt.LF;
				else
				$report .= intval($schluessel[0]+$wert['loecher']['anzahl']).' Tage lang mit '.$wert['loecher']['anzahl'].' Unterbrechung'.$durchschnitt.LF;
			}
		$report .= chr(9).chr(9).'von '.$DA->ZeitstempelNachLesbar($wert['start']).LF;
			if ( sizeof($wert['loecher']['details']) > 0 ){
				foreach ( $wert['loecher']['details'] as $datum=>$dwert )
				$report .= chr(9).chr(9).'  Unterbrechung am '.strftime('%A, %d. %B',strtotime($datum)).' mit '.$dwert.LF;
			}
		$report .= chr(9).chr(9).'bis '.$DA->ZeitstempelNachLesbar($wert['ende']).LF.LF;
		$a++;
		}
	$report .= LF.LF;
		if ( strlen($einstellungen['report']['lizenz_text']) > 20 )
		$report .= $einstellungen['report']['lizenz_text'];
		if ( strlen($einstellungen['report']['lizenz_uri']) > 8 )
		$report .= LF.$einstellungen['report']['lizenz_uri'];
	break;

	case 'html':
	$report .= '<!DOCTYPE html>'.LF;
	$report .= '<html>'.LF;
	$report .= '<head>'.LF;
	$report .= '<meta http-equiv="content-type" content="text/html;charset=utf-8"></meta>'.LF;
	$report .= '</head>'.LF;
	$report .= '<body>'.LF;
	$report .= '<h1>GEFUNDENE STRASSE IM ZEITRAUM '.htmlspecialchars($DA->cli_parameter['vergleich']).'</h1>'.LF;
	$report .= '<p>Erstellt am '.strftime(WADE_FDATE,time()).'<br />'.LF;
	$report .= 'Name der Station: '.htmlspecialchars($einstellungen['daten'][$DA->cli_parameter['station']]['name']).
		' ('.htmlspecialchars($einstellungen['daten'][$DA->cli_parameter['station']]['code']).')<br />'.LF;
	$report .= 'Daten-Quelle: '.htmlspecialchars($einstellungen['daten'][$DA->cli_parameter['station']]['quelle']).'<br />'.LF;
	$report .= 'Bedingung: '.htmlspecialchars($DA->cli_parameter['bedingung']).'</p>'.LF;
	$report .= 'Erlaubte Löcher: '.$einstellungen['strasse']['erlaubte_loecher'].'</p>'.LF;
		if ( !empty($einstellungen['strasse']['kommentar']) )
		$report .= '<p>'.$einstellungen['strasse']['kommentar'].'</p>'.LF;
	$a = 1;
	$report .= '<ol type="1">'.LF;
		foreach ( $ergebnis as $schluessel=>$wert ){
			if ( $a > (int)$einstellungen['strasse']['ergebnis_anzahl'] )
			break;
		$schluessel = explode(',',$schluessel);
			if ( $einstellungen['strasse']['durchschnitt_anzeigen'] )
			$durchschnitt = ' (∅ '.$DA->HuebscheZahlen($wert['durchschnitt'],1,false).')';
			else
			$durchschnitt = '';
		$report .= '<li>';
			if ( $wert['loecher']['anzahl'] === 0 )
			$report .= 'Durchgängig '.intval($schluessel[0]).' Tage lang'.$durchschnitt.LF;
			else{
				if ( $wert['loecher']['anzahl'] > 1 )
				$report .= intval($schluessel[0]+$wert['loecher']['anzahl']).' Tage lang mit '.$wert['loecher']['anzahl'].' Unterbrechungen'.$durchschnitt.LF;
				else
				$report .= intval($schluessel[0]+$wert['loecher']['anzahl']).' Tage lang mit '.$wert['loecher']['anzahl'].' Unterbrechung'.$durchschnitt.LF;
			}
		$report .= '<br />von '.$DA->ZeitstempelNachLesbar($wert['start']).LF;
			if ( sizeof($wert['loecher']['details']) > 0 ){
				foreach ( $wert['loecher']['details'] as $datum=>$dwert )
				$report .= '<br />&nbsp;&nbsp;Unterbrechung am '.strftime('%A, %d. %B',strtotime($datum)).' mit '.$dwert.LF;
			}
		$report .= '<br />bis '.$DA->ZeitstempelNachLesbar($wert['ende']).LF;
		$report .= '</li>'.LF;
		$a++;
		}
	$report .= '</ol>'.LF;
		if ( strlen($einstellungen['report']['lizenz_text']) > 20 ){
			if ( strlen($einstellungen['report']['lizenz_uri']) > 8 )
			$report .= '<a href="'.$einstellungen['report']['lizenz_uri'].'" target="_blank">'.htmlspecialchars($einstellungen['report']['lizenz_text']).'</a>'.LF;
			else
			$report .= htmlspecialchars($einstellungen['report']['lizenz_text']).LF;
		}
	$report .= '</body>'.LF;
	$report .= '</html>';
	break;

	case 'xml':
	$report .= '<?xml version="1.0" encoding="utf-8" standalone="yes"?>'.LF;
	$report .= '<strasse>'.LF;
		if ( !empty($einstellungen['strasse']['kommentar']) )
		$report .= '/* '.$einstellungen['strasse']['kommentar'].' */'.LF;
	$report .= '<meta>'.LF;
	$report .= chr(9).'<erstelltam>'.strftime(WADE_FDATE,time()).'</erstelltam>'.LF;
	$report .= chr(9).'<zeitraum>'.htmlspecialchars($DA->cli_parameter['vergleich']).'</zeitraum>'.LF;
	$report .= chr(9).'<name>'.htmlspecialchars($einstellungen['daten'][$DA->cli_parameter['station']]['name']).'</name>'.LF;
	$report .= chr(9).'<code>'.htmlspecialchars($einstellungen['daten'][$DA->cli_parameter['station']]['code']).'</code>'.LF;
	$report .= chr(9).'<datenquelle>'.htmlspecialchars($einstellungen['daten'][$DA->cli_parameter['station']]['quelle']).'</datenquelle>'.LF;
	$report .= chr(9).'<bedingung>'.htmlspecialchars($DA->cli_parameter['bedingung']).'</bedingung>'.LF;
	$report .= '</meta>'.LF;
	$report .= '<lizenz>'.LF;
	$report .= chr(9).'<name>'.htmlspecialchars($einstellungen['report']['lizenz_text']).'</name>'.LF;
	$report .= chr(9).'<uri>'.$einstellungen['report']['lizenz_uri'].'</uri>'.LF;
	$report .= '</lizenz>'.LF;
	$report .= '<daten>'.LF;
	$a = 1;
		foreach ( $ergebnis as $schluessel=>$wert ){
			if ( $a > (int)$einstellungen['strasse']['ergebnis_anzahl'] )
			break;
		$details = '';
			if ( sizeof($wert['loecher']['details']) > 0 ){
				foreach ( $wert['loecher']['details'] as $datum=>$dwert )
				$details .= ','.$datum.'='.$dwert;
			}
		$schluessel = explode(',',$schluessel);
		$report .= chr(9).'<datensatz>'.LF;
		$report .= chr(9).chr(9).'<dauer_tage>'.intval($schluessel[0]).'</dauer_tage>'.LF;
		$report .= chr(9).chr(9).'<anzahl_loecher>'.$wert['loecher']['anzahl'].'</anzahl_loecher>'.LF;
		$report .= chr(9).chr(9).'<loecher_details>'.substr($details,1).'</loecher_details>'.LF;
		$report .= chr(9).chr(9).'<datum_start>'.$wert['start'].'</datum_start>'.LF;
		$report .= chr(9).chr(9).'<datum_ende>'.$wert['ende'].'</datum_ende>'.LF;
			if ( $einstellungen['strasse']['durchschnitt_anzeigen'] )
			$report = chr(9).chr(9).'<durchschnitt>'.$DA->HuebscheZahlen($wert['durchschnitt'],1,false).'</durchschnitt>'.LF;
		$report .= chr(9).'</datensatz>'.LF;
		$a++;
		}
	$report .= '</daten>'.LF;
	$report .= '</strasse>';
	break;
	}

	if ( !empty($einstellungen['report']['ausgabe_datei_maske']) && is_writeable(dirname($einstellungen['report']['ausgabe_datei_maske'])) )
	file_put_contents($einstellungen['report']['ausgabe_datei_maske'],$report);
$DA->KonsolenAusgabe('Report erstellt in "'.$einstellungen['report']['ausgabe_datei_maske'].'"',1);
$DA->KonsolenAusgabe('Aufgaben erledigt. Ciao!',0);
?>
