<?php
/* =====================================================================
 * Dieses Skript ist Teil von "Wetter-Analyse in Dekaden (WADE)"
 * Von "Trixi aus Witten/NRW" - http://taw-wade.kilu.de/
 *                 Version 15.07.01 - Build 24.07.2015
 * Lizenziert unter "Namensnennung-Weitergabe unter gleichen Bedingungen
 * 3.0 Deutschland (CC BY-SA 3.0)"
 *                 ==> http://creativecommons.org/licenses/by-sa/3.0/de/
 *
 * Diese Software ist FREIE SOFTWARE und wird mit der Hoffnung, daß sie
 * nützlich sein könnte, zur Verfügung gestellt, jedoch OHNE JEDE
 * GEWÄHRLEISTUNG. Auch nicht für eine ALLGEMEINE GEBRAUCHSTAUGLICHKEIT
 * oder Stabilität für die NUTZUNG ZU EINEM BESTIMMTEN ZWECK. Die freie
 * Software, von der hier die Rede sein soll, ist kein "Freibier",
 * sondern sie gibt dir die Freiheiten
 *
 *   o  die Software für einen beliebigen Zweck auszuführen
 *   o  die Funktionsweise der Software zu studieren und sie an deine
 *      eigenen Bedürfnisse anzupassen
 *   o  Kopien der Software weiterzugeben
 *   o  sowie die Software zu verbessern und diese Verbesserungen zu
 *      veröffentlichen.
*/
// @module update "\t\tPrüft online, ob eine neue WADE-Version vorhanden ist\n"
$DA->KonsolenAusgabe('Beginne mit der Ausführung von '.basename(__FILE__),1);
$socket_optionen = array(
	'http'=>array(
		'protocol_version'=>1.1,
		'method'=>'GET',
		'header'=>"User-Agent: Wetter-Analyse in Dekaden/".WADE_VERSION_STRING." (http://taw-wade.kilu.de/)\r\n",
		)
);
	if ( $einstellungen['proxy']['http_benutzen'] && strlen($einstellungen['proxy']['http_hostname']) > 7 ){
	$socket_optionen['http']['proxy'] = 'tcp://'.$einstellungen['proxy']['http_hostname'];
	$socket_optionen['http']['request_fulluri'] = $einstellungen['proxy']['volle_uri_senden'];
	}
	if ( !extension_loaded('simplexml') )
	$DA->KonsolenAusgabe('Kann die Aktualisierung-Informationen nicht verarbeiten, weil PHP die "simplexml"-Erweiterung fehlt',-1);
	if ( $DA->cli_parameter['update_install'] )
	$DA->cli_parameter['update_download'] = true;

$DA->KonsolenAusgabe('Aktuell installierte Version ist "'.WADE_VERSION_STRING.'"',0);
$DA->KonsolenAusgabe('Frage den Update-Server nach Aktualisierung-Informationen...',1);
$context = stream_context_create($socket_optionen);
	if ( isset($_SERVER['LOCAL_UPDATE_FILE']) && (int)$_SERVER['LOCAL_UPDATE_FILE'] === 1 )
	$daten = file_get_contents('./online/update.xml');
	else{
	$daten = file_get_contents('http://taw-wade.kilu.de/update.xml',false,$context);
//	$header = implode("\r\n",$http_response_header);
//	$DA->KonsolenAusgabe(print_r($header,true),3);
	}
	if ( strlen($daten) > 128 && strpos($daten,'<wade_update_information>') ){
	$DA->KonsolenAusgabe('Daten erhalten. Prüfe nun die Einträge...',1);
	$update_daten = simplexml_load_string($daten);
		if ( isset($update_daten->api_version) && $update_daten->api_version < 2 )
		$DA->KonsolenAusgabe('Die Aktualisierung-Informationen haben ein veraltetes Format',-1);
	$versionen = array();
	$aktuell = '';
		if ( isset($update_daten->release) ){
			foreach ( $update_daten->release as $release ){
				if ( isset($release->public) && (bool)$release->public === false )
				continue;
				if ( version_compare((string)$release->version,WADE_VERSION_STRING,'>') )
				$versionen[(string)$release->version] = $release;
				if ( version_compare((string)$release->version,WADE_VERSION_STRING,'=') ){
				$aktuell = $release;
					if ( !isset($aktuell->update_max) )
					$aktuell->update_max = '99.99.99';
				}
			}
		}
		if ( sizeof($versionen) > 0 && is_object($aktuell) ){
		krsort($versionen);
			while ( $neuere_version = array_shift($versionen) ){
				if ( version_compare((string)$neuere_version->version,(string)$aktuell->update_max,'<=') )
				break;
			}
			if ( is_object($neuere_version) )
			$DA->KonsolenAusgabe('Die neueste Version auf dem Server ist "'.preg_replace('/[^\d\.]+/','',(string)$neuere_version->version).'"',0);
			else
			$DA->KonsolenAusgabe('Es gibt neuere Versionen, aber die dürfen laut Begrenzung (maximal "'.preg_replace('/[^\d\.]+/','',(string)$aktuell->update_max).'") nicht verwendet werden.',0);
		}
		else
		$DA->KonsolenAusgabe('Es wurde keine neuere Version als die installierte gefunden',0);

		if ( isset($neuere_version) && $DA->cli_parameter['update_download'] ){
		$DA->KonsolenAusgabe('Lade Datei vom Aktualisierung-Server herunter',1);
		$daten = file_get_contents((string)$neuere_version->uri_zip,false,$context);
			if ( is_string($daten) && strlen($daten) > 0 ){
			$DA->KonsolenAusgabe(strlen($daten).' Bytes vom Server geladen',1);
				if ( (string)$neuere_version->checksum_sha1_zip === sha1($daten) ){
				$DA->KonsolenAusgabe('Aktualisierungspaket hat eine korrekte Prüfsumme',1);
				$update_datei = tempnam('/tmp','wade');
				$sock = fopen($update_datei,'wb');
				fwrite($sock,$daten);
				fclose($sock);
					if ( $DA->cli_parameter['update_install'] ){
					$begrenzung = str_replace(array('.','*',','),array('\.','[a-z0-9_\.\-]+','|'),$neuere_version->constraint_list);
					$lokale_dateien = scandir('.');
					$transaktionen = array();
					$geschrieben = array();
					$abbruch = false;
						if ( extension_loaded('zip') ){
						$DA->KonsolenAusgabe('Beginne mit der Installation der Dateien',1);
						$DA->KonsolenAusgabe('Erzeuge Transaktion, um das Aktualisieren zu simulieren',1);
						$zip = zip_open($update_datei);
							while ( $zip_datei = zip_read($zip) ){
							$zip_name = basename(zip_entry_name($zip_datei));
							$DA->KonsolenAusgabe('Bearbeite "'.$zip_name.'" des Aktualisierungspakets',2);
								if ( preg_match('/^('.$begrenzung.')$/iuD',$zip_name) ){
									if ( zip_entry_open($zip,$zip_datei,'r') ){
									$zip_inhalt = zip_entry_read($zip_datei,zip_entry_filesize($zip_datei));
									zip_entry_close($zip_datei);
									}
									else
									$zip_inhalt = false;
									if ( in_array($zip_name,$lokale_dateien,true) ){
										if ( is_writeable($zip_name) && $zip_inhalt !== false ){
										$transaktionen[] = array('aktion'=>'U','pfad'=>$zip_name,'inhalt'=>$zip_inhalt);
										$geschrieben[] = $zip_name;
										$DA->KonsolenAusgabe('Transaktion: Aktualisieren (Größe: '.strlen($zip_inhalt).' Bytes)',2);
										}
										else{
										$DA->KonsolenAusgabe('Die Datei "'.$zip_name.'" kann nicht aktualisiert werden',0);
										$transaktionen = array();
										$abbruch = true;
										}
									}
									else{
										if ( is_writeable('.') && $zip_inhalt !== false ){
										$transaktionen[] = array('aktion'=>'A','pfad'=>$zip_name,'inhalt'=>$zip_inhalt);
										$geschrieben[] = $zip_name;
										$DA->KonsolenAusgabe('Transaktion: Erstellen (Größe: '.strlen($zip_inhalt).' Bytes)',2);
										}
										else{
										$DA->KonsolenAusgabe('Die Datei "'.$zip_name.'" kann nicht geschrieben werden',0);
										$transaktionen = array();
										$abbruch = true;
										}
									}
								}
								else
								$DA->KonsolenAusgabe('Ignoriere es, da nicht in der Begrenzungsliste',2);
							}
						zip_close($zip);
					$begrenzung = str_replace(array('.','*',','),array('\.','[a-z0-9_\.\-]+','|'),$aktuelle_version->constraint_list);
							foreach ( $lokale_dateien as $datei ){
								if ( $abbruch )
								break;
							$DA->KonsolenAusgabe('Bearbeite "'.$datei.'" der lokalen Dateien',2);
								if ( preg_match('/^('.$begrenzung.')$/iuD',$datei) ){
									if ( in_array($datei,$geschrieben) )
									continue;
									if ( is_writeable('.') && is_writeable($datei) ){
									$transaktionen[] = array('aktion'=>'D','pfad'=>$datei,'inhalt'=>false);
									$DA->KonsolenAusgabe('Transaktion: Löschen',2);
									}
									else{
									$DA->KonsolenAusgabe('Die Datei "'.$datei.'" kann nicht entfernt werden',0);
									$transaktionen = array();
									break;
									}
								}
								else
								$DA->KonsolenAusgabe('Ignoriere es, da nicht in der Begrenzungsliste',2);
							}
							if ( sizeof($transaktionen) > 0 ){
							$DA->KonsolenAusgabe('Transaktion war erfolgreich. Führe nun die Aktualisierung aus.',1);
								foreach ( $transaktionen as $id=>$datei ){
								$DA->KonsolenAusgabe('#'.$id.' '.$datei['aktion'].' '.$datei['pfad'],2);
									switch ( $datei['aktion'] ){
									case 'A':
										if ( !defined('HEY_DONT_YOU_CHANGE_DATA') )
										file_put_contents($datei['pfad'],$datei['inhalt']);
									break;
									case 'U':
										if ( !defined('HEY_DONT_YOU_CHANGE_DATA') )
										file_put_contents($datei['pfad'],$datei['inhalt']);
									break;
									case 'D':
										if ( !defined('HEY_DONT_YOU_CHANGE_DATA') )
										unlink($datei['pfad']);
									break;
									}
								}
							$DA->KonsolenAusgabe('WADE wurde auf Version "'.preg_replace('/[^\d\.]+/','',(string)$neuere_version->version).'" aktualisiert',0);
							}
							else
							$DA->KonsolenAusgabe('Transaktion mißlungen. Breche hier ohne Aktualisierung ab.',1);
						}
						else
						$DA->KonsolenAusgabe('Kann die Aktualisierung nicht installieren, weil PHP die "zip"-Erweiterung fehlt',0);
					}
				@unlink($update_datei);
				}
				else
				$DA->KonsolenAusgabe('Das Aktualisierungspaket hat eine falsche Prüfsumme',0);
			}
			else
			$DA->KonsolenAusgabe('Das Aktualisierungspaket konnte nicht heruntergeladen werden',0);
		}
	}
	else
	$DA->KonsolenAusgabe('Konnte keine Verbindung zum Aktualisierung-Server aufbauen',0);

$DA->KonsolenAusgabe('Aktualisierung-Operation abgeschlossen',1);
?>
